/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2017 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "WebPreferences.h"

#include "WebPreferencesKeys.h"

namespace WebKit {

void WebPreferences::setAccessibilityObjectModelEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::accessibilityObjectModelEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::accessibilityObjectModelEnabledKey(), value);
}

bool WebPreferences::accessibilityObjectModelEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::accessibilityObjectModelEnabledKey());
}

void WebPreferences::setAdClickAttributionDebugModeEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::adClickAttributionDebugModeEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::adClickAttributionDebugModeEnabledKey(), value);
}

bool WebPreferences::adClickAttributionDebugModeEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::adClickAttributionDebugModeEnabledKey());
}

void WebPreferences::setAdClickAttributionEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::adClickAttributionEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::adClickAttributionEnabledKey(), value);
}

bool WebPreferences::adClickAttributionEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::adClickAttributionEnabledKey());
}

void WebPreferences::setBlankAnchorTargetImpliesNoOpenerEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::blankAnchorTargetImpliesNoOpenerEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::blankAnchorTargetImpliesNoOpenerEnabledKey(), value);
}

bool WebPreferences::blankAnchorTargetImpliesNoOpenerEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::blankAnchorTargetImpliesNoOpenerEnabledKey());
}

void WebPreferences::setCSSCustomPropertiesAndValuesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssCustomPropertiesAndValuesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssCustomPropertiesAndValuesEnabledKey(), value);
}

bool WebPreferences::cssCustomPropertiesAndValuesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssCustomPropertiesAndValuesEnabledKey());
}

void WebPreferences::setCSSPaintingAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssPaintingAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssPaintingAPIEnabledKey(), value);
}

bool WebPreferences::cssPaintingAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssPaintingAPIEnabledKey());
}

void WebPreferences::setCSSTypedOMEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssTypedOMEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::cssTypedOMEnabledKey(), value);
}

bool WebPreferences::cssTypedOMEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssTypedOMEnabledKey());
}

void WebPreferences::setCoreMathMLEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::coreMathMLEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::coreMathMLEnabledKey(), value);
}

bool WebPreferences::coreMathMLEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::coreMathMLEnabledKey());
}

void WebPreferences::setFetchAPIKeepAliveEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), value);
}

bool WebPreferences::fetchAPIKeepAliveEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fetchAPIKeepAliveEnabledKey());
}

void WebPreferences::setGoogleAntiFlickerOptimizationQuirkEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::googleAntiFlickerOptimizationQuirkEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::googleAntiFlickerOptimizationQuirkEnabledKey(), value);
}

bool WebPreferences::googleAntiFlickerOptimizationQuirkEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::googleAntiFlickerOptimizationQuirkEnabledKey());
}

void WebPreferences::setHTTPSUpgradeEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::httpSUpgradeEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::httpSUpgradeEnabledKey(), value);
}

bool WebPreferences::httpSUpgradeEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::httpSUpgradeEnabledKey());
}

void WebPreferences::setImageBitmapOffscreenCanvasEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey(), value);
}

bool WebPreferences::imageBitmapOffscreenCanvasEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::imageBitmapOffscreenCanvasEnabledKey());
}

void WebPreferences::setIntersectionObserverEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::intersectionObserverEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::intersectionObserverEnabledKey(), value);
}

bool WebPreferences::intersectionObserverEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::intersectionObserverEnabledKey());
}

void WebPreferences::setLazyImageLoadingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::lazyImageLoadingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::lazyImageLoadingEnabledKey(), value);
}

bool WebPreferences::lazyImageLoadingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::lazyImageLoadingEnabledKey());
}

void WebPreferences::setLinkPrefetchEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::linkPrefetchEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::linkPrefetchEnabledKey(), value);
}

bool WebPreferences::linkPrefetchEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::linkPrefetchEnabledKey());
}

void WebPreferences::setLinkPreloadResponsiveImagesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::linkPreloadResponsiveImagesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::linkPreloadResponsiveImagesEnabledKey(), value);
}

bool WebPreferences::linkPreloadResponsiveImagesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::linkPreloadResponsiveImagesEnabledKey());
}

void WebPreferences::setMediaCapabilitiesExtensionsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::mediaCapabilitiesExtensionsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::mediaCapabilitiesExtensionsEnabledKey(), value);
}

bool WebPreferences::mediaCapabilitiesExtensionsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::mediaCapabilitiesExtensionsEnabledKey());
}

void WebPreferences::setMediaRecorderEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::mediaRecorderEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::mediaRecorderEnabledKey(), value);
}

bool WebPreferences::mediaRecorderEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::mediaRecorderEnabledKey());
}

void WebPreferences::setPageAtRuleSupportEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::pageAtRuleSupportEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::pageAtRuleSupportEnabledKey(), value);
}

bool WebPreferences::pageAtRuleSupportEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::pageAtRuleSupportEnabledKey());
}

void WebPreferences::setPointerEventsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::pointerEventsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::pointerEventsEnabledKey(), value);
}

bool WebPreferences::pointerEventsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::pointerEventsEnabledKey());
}

void WebPreferences::setProcessSwapOnCrossSiteNavigationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::processSwapOnCrossSiteNavigationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::processSwapOnCrossSiteNavigationEnabledKey(), value);
}

bool WebPreferences::processSwapOnCrossSiteNavigationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::processSwapOnCrossSiteNavigationEnabledKey());
}

void WebPreferences::setReferrerPolicyAttributeEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::referrerPolicyAttributeEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::referrerPolicyAttributeEnabledKey(), value);
}

bool WebPreferences::referrerPolicyAttributeEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::referrerPolicyAttributeEnabledKey());
}

void WebPreferences::setResizeObserverEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::resizeObserverEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::resizeObserverEnabledKey(), value);
}

bool WebPreferences::resizeObserverEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::resizeObserverEnabledKey());
}

void WebPreferences::setScreenCaptureEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::screenCaptureEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::screenCaptureEnabledKey(), value);
}

bool WebPreferences::screenCaptureEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::screenCaptureEnabledKey());
}

void WebPreferences::setServerTimingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::serverTimingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::serverTimingEnabledKey(), value);
}

bool WebPreferences::serverTimingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::serverTimingEnabledKey());
}

void WebPreferences::setSpringTimingFunctionEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::springTimingFunctionEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::springTimingFunctionEnabledKey(), value);
}

bool WebPreferences::springTimingFunctionEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::springTimingFunctionEnabledKey());
}

void WebPreferences::setSyntheticEditingCommandsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::syntheticEditingCommandsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::syntheticEditingCommandsEnabledKey(), value);
}

bool WebPreferences::syntheticEditingCommandsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::syntheticEditingCommandsEnabledKey());
}

void WebPreferences::setThirdPartyIframeRedirectBlockingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::thirdPartyIframeRedirectBlockingEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::thirdPartyIframeRedirectBlockingEnabledKey(), value);
}

bool WebPreferences::thirdPartyIframeRedirectBlockingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::thirdPartyIframeRedirectBlockingEnabledKey());
}

void WebPreferences::setVisualViewportAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::visualViewportAPIEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::visualViewportAPIEnabledKey(), value);
}

bool WebPreferences::visualViewportAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::visualViewportAPIEnabledKey());
}

void WebPreferences::setWebAnimationsCSSIntegrationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), value);
}

bool WebPreferences::webAnimationsCSSIntegrationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey());
}

void WebPreferences::setWebAnimationsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAnimationsEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAnimationsEnabledKey(), value);
}

bool WebPreferences::webAnimationsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAnimationsEnabledKey());
}

void WebPreferences::setWebAuthenticationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAuthenticationEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webAuthenticationEnabledKey(), value);
}

bool WebPreferences::webAuthenticationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAuthenticationEnabledKey());
}

void WebPreferences::setWebGL2Enabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGL2EnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGL2EnabledKey(), value);
}

bool WebPreferences::webGL2Enabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGL2EnabledKey());
}

void WebPreferences::setWebGPUEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webGPUEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webGPUEnabledKey(), value);
}

bool WebPreferences::webGPUEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webGPUEnabledKey());
}

void WebPreferences::setWebRTCDTMFEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCDTMFEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webRTCDTMFEnabledKey(), value);
}

bool WebPreferences::webRTCDTMFEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCDTMFEnabledKey());
}

void WebPreferences::setWebRTCMDNSICECandidatesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCMDNSICECandidatesEnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webRTCMDNSICECandidatesEnabledKey(), value);
}

bool WebPreferences::webRTCMDNSICECandidatesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCMDNSICECandidatesEnabledKey());
}

void WebPreferences::setWebSQLDisabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webSQLDisabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webSQLDisabledKey(), value);
}

bool WebPreferences::webSQLDisabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webSQLDisabledKey());
}

void WebPreferences::setWebVREnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webVREnabledKey(), value))
        return;
    updateBoolValueForExperimentalFeatureKey(WebPreferencesKey::webVREnabledKey(), value);
}

bool WebPreferences::webVREnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webVREnabledKey());
}

const Vector<RefPtr<API::Object>>& WebPreferences::experimentalFeatures()
{
    static NeverDestroyed<Vector<RefPtr<API::Object>>> features(std::initializer_list<RefPtr<API::Object>> {
        API::ExperimentalFeature::create("Accessibility Object Model", "AccessibilityObjectModelEnabled", "Accessibility Object Model support", false, false),
        API::ExperimentalFeature::create("Ad Click Attribution Debug Mode", "AdClickAttributionDebugModeEnabled", "Enable Ad Click Attribution Debug Mode", false, false),
        API::ExperimentalFeature::create("Ad Click Attribution", "AdClickAttributionEnabled", "Enable Ad Click Attribution for Cross-Site Link Navigations", false, false),
        API::ExperimentalFeature::create("Blank anchor target implies rel=noopener", "BlankAnchorTargetImpliesNoOpenerEnabled", "target=_blank on anchor elements implies rel=noopener", true, false),
        API::ExperimentalFeature::create("CSS Custom Properties and Values API", "CSSCustomPropertiesAndValuesEnabled", "Enable CSS Custom Properties and Values API", false, false),
#if ENABLE(CSS_PAINTING_API)
        API::ExperimentalFeature::create("CSS Painting API", "CSSPaintingAPIEnabled", "Enable the CSS Painting API", false, false),
#endif
#if ENABLE(CSS_TYPED_OM)
        API::ExperimentalFeature::create("CSS Typed OM", "CSSTypedOMEnabled", "Enable the CSS Typed OM", false, false),
#endif
        API::ExperimentalFeature::create("MathML Core", "CoreMathMLEnabled", "Disable features removed from the MathML Core spec.", DEFAULT_CORE_MATHML_ENABLED, false),
        API::ExperimentalFeature::create("Fetch API Request KeepAlive", "FetchAPIKeepAliveEnabled", "Enable Fetch API Request KeepAlive", true, false),
        API::ExperimentalFeature::create("Quirk to prevent delayed initial painting on sites using Google's Anti-Flicker optimization", "GoogleAntiFlickerOptimizationQuirkEnabled", "Quirk to prevent delayed initial painting on sites using Google's Anti-Flicker optimization", true, false),
        API::ExperimentalFeature::create("Automatic HTTPS upgrade", "HTTPSUpgradeEnabled", "Automatic HTTPS upgrade for known supported sites", false, false),
        API::ExperimentalFeature::create("ImageBitmap and OffscreenCanvas", "ImageBitmapOffscreenCanvasEnabled", "Support for the ImageBitmap and OffscreenCanvas APIs", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#if ENABLE(INTERSECTION_OBSERVER)
        API::ExperimentalFeature::create("Intersection Observer", "IntersectionObserverEnabled", "Enable Intersection Observer support", true, false),
#endif
        API::ExperimentalFeature::create("Lazy Image Loading", "LazyImageLoadingEnabled", "Enable Lazy Image Loading support", false, false),
        API::ExperimentalFeature::create("LinkPrefetch", "LinkPrefetchEnabled", "Enable LinkedPrefetch", false, false),
        API::ExperimentalFeature::create("Link preload responsive images", "LinkPreloadResponsiveImagesEnabled", "Enable link preload responsive images", false, false),
        API::ExperimentalFeature::create("Media Capabilities Extensions", "MediaCapabilitiesExtensionsEnabled", "Media Capabilities Extensions", true, false),
#if ENABLE(MEDIA_STREAM)
        API::ExperimentalFeature::create("MediaRecorder", "MediaRecorderEnabled", "MediaRecorder", false, false),
#endif
        API::ExperimentalFeature::create("@page CSS at-rule support", "PageAtRuleSupportEnabled", "Enable @page support", false, false),
        API::ExperimentalFeature::create("Pointer Events", "PointerEventsEnabled", "Enable Pointer Events", true, false),
        API::ExperimentalFeature::create("Swap Processes on Cross-Site Navigation", "ProcessSwapOnCrossSiteNavigationEnabled", "Swap WebContent processes on cross-site navigations", DEFAULT_PROCESS_SWAP_ON_CROSS_SITE_NAVIGATION_ENABLED, false),
        API::ExperimentalFeature::create("Referrer Policy attribute", "ReferrerPolicyAttributeEnabled", "Enable Referrer Policy attribute", false, false),
#if ENABLE(RESIZE_OBSERVER)
        API::ExperimentalFeature::create("Resize Observer", "ResizeObserverEnabled", "Enable Resize Observer support", false, false),
#endif
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
        API::ExperimentalFeature::create("ScreenCapture", "ScreenCaptureEnabled", "Enable ScreenCapture", true, false),
#endif
        API::ExperimentalFeature::create("Server Timing", "ServerTimingEnabled", "Enable Server Timing API", false, false),
        API::ExperimentalFeature::create("CSS Spring Animations", "SpringTimingFunctionEnabled", "CSS Spring Animation prototype", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
        API::ExperimentalFeature::create("Synthetic Editing Commands", "SyntheticEditingCommandsEnabled", "Enable Synthetic Editing Commands", true, false),
        API::ExperimentalFeature::create("Block top-level redirects by third-party iframes", "ThirdPartyIframeRedirectBlockingEnabled", "Block top-level redirects by third-party iframes", true, false),
        API::ExperimentalFeature::create("Visual Viewport API", "VisualViewportAPIEnabled", "Enable Visual Viewport API", true, false),
        API::ExperimentalFeature::create("CSS Animations via Web Animations", "WebAnimationsCSSIntegrationEnabled", "Expose CSS Animations and CSS Transitions through getAnimations()", false, false),
        API::ExperimentalFeature::create("Web Animations", "WebAnimationsEnabled", "Web Animations prototype", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#if ENABLE(WEB_AUTHN)
        API::ExperimentalFeature::create("Web Authentication", "WebAuthenticationEnabled", "Enable Web Authentication support", DEFAULT_WEB_AUTHENTICATION_ENABLED, false),
#endif
#if ENABLE(WEBGL2)
        API::ExperimentalFeature::create("WebGL 2.0", "WebGL2Enabled", "WebGL 2 prototype", false, false),
#endif
#if ENABLE(WEBGPU)
        API::ExperimentalFeature::create("WebGPU", "WebGPUEnabled", "WebGPU Sketch prototype", false, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC DTMF", "WebRTCDTMFEnabled", "Enable WebRTC DTMF", true, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC mDNS ICE candidates", "WebRTCMDNSICECandidatesEnabled", "Enable WebRTC mDNS ICE candidates", true, false),
#endif
        API::ExperimentalFeature::create("Disable Web SQL", "WebSQLDisabled", "Disable Web SQL", true, false),
#if PLATFORM(GTK) || PLATFORM(WPE)
        API::ExperimentalFeature::create("WebVR", "WebVREnabled", "WebVR Module support", DEFAULT_EXPERIMENTAL_FEATURES_ENABLED, false),
#endif
    });

    return features;
}

bool WebPreferences::isFeatureEnabled(const API::ExperimentalFeature& feature) const
{
    struct FeatureGetterMapping {
        const char* name;
        bool (WebPreferences::*function) () const;
    };

    static FeatureGetterMapping getters[] = {
        { "AccessibilityObjectModelEnabled", &WebPreferences::accessibilityObjectModelEnabled },
        { "AdClickAttributionDebugModeEnabled", &WebPreferences::adClickAttributionDebugModeEnabled },
        { "AdClickAttributionEnabled", &WebPreferences::adClickAttributionEnabled },
        { "BlankAnchorTargetImpliesNoOpenerEnabled", &WebPreferences::blankAnchorTargetImpliesNoOpenerEnabled },
        { "CSSCustomPropertiesAndValuesEnabled", &WebPreferences::cssCustomPropertiesAndValuesEnabled },
#if ENABLE(CSS_PAINTING_API)
        { "CSSPaintingAPIEnabled", &WebPreferences::cssPaintingAPIEnabled },
#endif
#if ENABLE(CSS_TYPED_OM)
        { "CSSTypedOMEnabled", &WebPreferences::cssTypedOMEnabled },
#endif
        { "CoreMathMLEnabled", &WebPreferences::coreMathMLEnabled },
        { "FetchAPIKeepAliveEnabled", &WebPreferences::fetchAPIKeepAliveEnabled },
        { "GoogleAntiFlickerOptimizationQuirkEnabled", &WebPreferences::googleAntiFlickerOptimizationQuirkEnabled },
        { "HTTPSUpgradeEnabled", &WebPreferences::httpSUpgradeEnabled },
        { "ImageBitmapOffscreenCanvasEnabled", &WebPreferences::imageBitmapOffscreenCanvasEnabled },
#if ENABLE(INTERSECTION_OBSERVER)
        { "IntersectionObserverEnabled", &WebPreferences::intersectionObserverEnabled },
#endif
        { "LazyImageLoadingEnabled", &WebPreferences::lazyImageLoadingEnabled },
        { "LinkPrefetchEnabled", &WebPreferences::linkPrefetchEnabled },
        { "LinkPreloadResponsiveImagesEnabled", &WebPreferences::linkPreloadResponsiveImagesEnabled },
        { "MediaCapabilitiesExtensionsEnabled", &WebPreferences::mediaCapabilitiesExtensionsEnabled },
#if ENABLE(MEDIA_STREAM)
        { "MediaRecorderEnabled", &WebPreferences::mediaRecorderEnabled },
#endif
        { "PageAtRuleSupportEnabled", &WebPreferences::pageAtRuleSupportEnabled },
        { "PointerEventsEnabled", &WebPreferences::pointerEventsEnabled },
        { "ProcessSwapOnCrossSiteNavigationEnabled", &WebPreferences::processSwapOnCrossSiteNavigationEnabled },
        { "ReferrerPolicyAttributeEnabled", &WebPreferences::referrerPolicyAttributeEnabled },
#if ENABLE(RESIZE_OBSERVER)
        { "ResizeObserverEnabled", &WebPreferences::resizeObserverEnabled },
#endif
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
        { "ScreenCaptureEnabled", &WebPreferences::screenCaptureEnabled },
#endif
        { "ServerTimingEnabled", &WebPreferences::serverTimingEnabled },
        { "SpringTimingFunctionEnabled", &WebPreferences::springTimingFunctionEnabled },
        { "SyntheticEditingCommandsEnabled", &WebPreferences::syntheticEditingCommandsEnabled },
        { "ThirdPartyIframeRedirectBlockingEnabled", &WebPreferences::thirdPartyIframeRedirectBlockingEnabled },
        { "VisualViewportAPIEnabled", &WebPreferences::visualViewportAPIEnabled },
        { "WebAnimationsCSSIntegrationEnabled", &WebPreferences::webAnimationsCSSIntegrationEnabled },
        { "WebAnimationsEnabled", &WebPreferences::webAnimationsEnabled },
#if ENABLE(WEB_AUTHN)
        { "WebAuthenticationEnabled", &WebPreferences::webAuthenticationEnabled },
#endif
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::webGL2Enabled },
#endif
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::webGPUEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCDTMFEnabled", &WebPreferences::webRTCDTMFEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCMDNSICECandidatesEnabled", &WebPreferences::webRTCMDNSICECandidatesEnabled },
#endif
        { "WebSQLDisabled", &WebPreferences::webSQLDisabled },
#if PLATFORM(GTK) || PLATFORM(WPE)
        { "WebVREnabled", &WebPreferences::webVREnabled },
#endif
    };

    const String& key = feature.key();

    for (auto& getter : getters) {
        if (key == getter.name)
            return (this->*getter.function)();
    }

    return false;
}

void WebPreferences::setFeatureEnabled(const API::ExperimentalFeature& feature, bool value)
{
    setExperimentalFeatureEnabledForKey(feature.key(), value);
}

void WebPreferences::setExperimentalFeatureEnabledForKey(const String& key, bool value)
{
    struct FeatureSetterMapping {
        const char* name;
        void (WebPreferences::*function) (const bool&);
    };

    static FeatureSetterMapping setters[] = {
        { "AccessibilityObjectModelEnabled", &WebPreferences::setAccessibilityObjectModelEnabled },
        { "AdClickAttributionDebugModeEnabled", &WebPreferences::setAdClickAttributionDebugModeEnabled },
        { "AdClickAttributionEnabled", &WebPreferences::setAdClickAttributionEnabled },
        { "BlankAnchorTargetImpliesNoOpenerEnabled", &WebPreferences::setBlankAnchorTargetImpliesNoOpenerEnabled },
        { "CSSCustomPropertiesAndValuesEnabled", &WebPreferences::setCSSCustomPropertiesAndValuesEnabled },
#if ENABLE(CSS_PAINTING_API)
        { "CSSPaintingAPIEnabled", &WebPreferences::setCSSPaintingAPIEnabled },
#endif
#if ENABLE(CSS_TYPED_OM)
        { "CSSTypedOMEnabled", &WebPreferences::setCSSTypedOMEnabled },
#endif
        { "CoreMathMLEnabled", &WebPreferences::setCoreMathMLEnabled },
        { "FetchAPIKeepAliveEnabled", &WebPreferences::setFetchAPIKeepAliveEnabled },
        { "GoogleAntiFlickerOptimizationQuirkEnabled", &WebPreferences::setGoogleAntiFlickerOptimizationQuirkEnabled },
        { "HTTPSUpgradeEnabled", &WebPreferences::setHTTPSUpgradeEnabled },
        { "ImageBitmapOffscreenCanvasEnabled", &WebPreferences::setImageBitmapOffscreenCanvasEnabled },
#if ENABLE(INTERSECTION_OBSERVER)
        { "IntersectionObserverEnabled", &WebPreferences::setIntersectionObserverEnabled },
#endif
        { "LazyImageLoadingEnabled", &WebPreferences::setLazyImageLoadingEnabled },
        { "LinkPrefetchEnabled", &WebPreferences::setLinkPrefetchEnabled },
        { "LinkPreloadResponsiveImagesEnabled", &WebPreferences::setLinkPreloadResponsiveImagesEnabled },
        { "MediaCapabilitiesExtensionsEnabled", &WebPreferences::setMediaCapabilitiesExtensionsEnabled },
#if ENABLE(MEDIA_STREAM)
        { "MediaRecorderEnabled", &WebPreferences::setMediaRecorderEnabled },
#endif
        { "PageAtRuleSupportEnabled", &WebPreferences::setPageAtRuleSupportEnabled },
        { "PointerEventsEnabled", &WebPreferences::setPointerEventsEnabled },
        { "ProcessSwapOnCrossSiteNavigationEnabled", &WebPreferences::setProcessSwapOnCrossSiteNavigationEnabled },
        { "ReferrerPolicyAttributeEnabled", &WebPreferences::setReferrerPolicyAttributeEnabled },
#if ENABLE(RESIZE_OBSERVER)
        { "ResizeObserverEnabled", &WebPreferences::setResizeObserverEnabled },
#endif
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
        { "ScreenCaptureEnabled", &WebPreferences::setScreenCaptureEnabled },
#endif
        { "ServerTimingEnabled", &WebPreferences::setServerTimingEnabled },
        { "SpringTimingFunctionEnabled", &WebPreferences::setSpringTimingFunctionEnabled },
        { "SyntheticEditingCommandsEnabled", &WebPreferences::setSyntheticEditingCommandsEnabled },
        { "ThirdPartyIframeRedirectBlockingEnabled", &WebPreferences::setThirdPartyIframeRedirectBlockingEnabled },
        { "VisualViewportAPIEnabled", &WebPreferences::setVisualViewportAPIEnabled },
        { "WebAnimationsCSSIntegrationEnabled", &WebPreferences::setWebAnimationsCSSIntegrationEnabled },
        { "WebAnimationsEnabled", &WebPreferences::setWebAnimationsEnabled },
#if ENABLE(WEB_AUTHN)
        { "WebAuthenticationEnabled", &WebPreferences::setWebAuthenticationEnabled },
#endif
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::setWebGL2Enabled },
#endif
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::setWebGPUEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCDTMFEnabled", &WebPreferences::setWebRTCDTMFEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCMDNSICECandidatesEnabled", &WebPreferences::setWebRTCMDNSICECandidatesEnabled },
#endif
        { "WebSQLDisabled", &WebPreferences::setWebSQLDisabled },
#if PLATFORM(GTK) || PLATFORM(WPE)
        { "WebVREnabled", &WebPreferences::setWebVREnabled },
#endif
    };

    for (auto& setter : setters) {
        if (key == setter.name) {
            (this->*setter.function)(value);
            return;
        }
    }
}

void WebPreferences::enableAllExperimentalFeatures()
{
    setAccessibilityObjectModelEnabled(true);
    setAdClickAttributionDebugModeEnabled(true);
    setAdClickAttributionEnabled(true);
    setBlankAnchorTargetImpliesNoOpenerEnabled(true);
    setCSSCustomPropertiesAndValuesEnabled(true);
#if ENABLE(CSS_PAINTING_API)
    setCSSPaintingAPIEnabled(true);
#endif
#if ENABLE(CSS_TYPED_OM)
    setCSSTypedOMEnabled(true);
#endif
    setCoreMathMLEnabled(true);
    setFetchAPIKeepAliveEnabled(true);
    setGoogleAntiFlickerOptimizationQuirkEnabled(true);
    setHTTPSUpgradeEnabled(true);
    setImageBitmapOffscreenCanvasEnabled(true);
#if ENABLE(INTERSECTION_OBSERVER)
    setIntersectionObserverEnabled(true);
#endif
    setLazyImageLoadingEnabled(true);
    setLinkPrefetchEnabled(true);
    setLinkPreloadResponsiveImagesEnabled(true);
    setMediaCapabilitiesExtensionsEnabled(true);
#if ENABLE(MEDIA_STREAM)
    setMediaRecorderEnabled(true);
#endif
    setPageAtRuleSupportEnabled(true);
    setPointerEventsEnabled(true);
    setProcessSwapOnCrossSiteNavigationEnabled(true);
    setReferrerPolicyAttributeEnabled(true);
#if ENABLE(RESIZE_OBSERVER)
    setResizeObserverEnabled(true);
#endif
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
    setScreenCaptureEnabled(true);
#endif
    setServerTimingEnabled(true);
    setSpringTimingFunctionEnabled(true);
    setSyntheticEditingCommandsEnabled(true);
    setThirdPartyIframeRedirectBlockingEnabled(true);
    setVisualViewportAPIEnabled(true);
    setWebAnimationsCSSIntegrationEnabled(true);
    setWebAnimationsEnabled(true);
#if ENABLE(WEB_AUTHN)
    setWebAuthenticationEnabled(true);
#endif
#if ENABLE(WEBGL2)
    setWebGL2Enabled(true);
#endif
#if ENABLE(WEBGPU)
    setWebGPUEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCDTMFEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCMDNSICECandidatesEnabled(true);
#endif
    setWebSQLDisabled(true);
#if PLATFORM(GTK) || PLATFORM(WPE)
    setWebVREnabled(true);
#endif
}

}
